import 'package:cross_file/cross_file.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';
import 'package:flutter/widgets.dart';
import 'package:flutterx_drop_view/src/drag_operation.dart';
import 'package:flutterx_live_data/flutterx_live_data.dart';

class RawDropView extends StatefulWidget {
  final DragOperation dragOperation;
  final SystemMouseCursor? cursor;
  final Set<String> mimeTypes;
  final bool throwOnMimeTypeNotMatch;
  final bool multiple;
  final void Function(Stream<XFile> files) onDrop;
  final Widget Function(BuildContext context, LiveData<bool> dragging) builder;

  const RawDropView({
    Key? key,
    this.dragOperation = DragOperation.copy,
    this.cursor,
    this.mimeTypes = const {},
    this.throwOnMimeTypeNotMatch = false,
    this.multiple = false,
    required this.onDrop,
    required this.builder,
  }) : super(key: key);

  @override
  State<RawDropView> createState() => _RawDropViewState();

  @override
  void debugFillProperties(DiagnosticPropertiesBuilder properties) {
    super.debugFillProperties(properties);
    properties
      ..add(EnumProperty<DragOperation>('dragOperation', dragOperation))
      ..add(DiagnosticsProperty<SystemMouseCursor?>('cursor', cursor))
      ..add(IterableProperty<String>('mimeTypes', mimeTypes))
      ..add(DiagnosticsProperty<bool>('throwOnMimeTypeNotMatch', throwOnMimeTypeNotMatch))
      ..add(DiagnosticsProperty<bool>('multiple', multiple))
      ..add(ObjectFlagProperty<void Function(Stream<XFile> files)>.has('onDrop', onDrop))
      ..add(ObjectFlagProperty<Widget Function(BuildContext context, LiveData<bool> dragging)>.has('builder', builder));
  }

  static Stream<XFile> pickFiles({Set<String> mimeTypes = const {}, bool multiple = false}) async* {}
}

class _RawDropViewState extends State<RawDropView> {
  @override
  Widget build(BuildContext context) => widget.builder(context, const ImmutableLiveData(false));
}
